<?php
session_start();

header('Access-Control-Allow-Origin: *'); 
header('Content-Type: application/json');

include 'conBD.php';

if (isset($_GET['opcio']))
{
	$opcio = $_GET['opcio'];
}

switch($opcio){
	
	/******************************************************************************************************/
	case 'disponibilitat': 	// Comprova la disponibilitat de Cal Candi
	/******************************************************************************************************/
		$reserva = $_POST['reserva']; // Recull les dades
		$dataInici = $_POST['dataInici'];
		$dataFi = $_POST['dataFi'];
		
		$ple = array();
		if ($reserva==1) { //Si reservem l'allotjament
			$query= "SELECT a.id 
							  FROM allotjament a
							  WHERE NOT EXISTS (
									 SELECT NULL
									   FROM reserva r
									  WHERE r.idHabitacio = a.id
										AND '$dataInici' <= r.dataFi
										AND '$dataFi' >= r.dataInici)
							 ORDER BY a.id"; //Busquem les habitacions lliures entre les dates que hem posat
				 
				if ($resultat = $mysqli->query($query)) { 	// Consultem totes les reserves de la bases de dades
						while($row = $resultat->fetch_array()) {
							$ple[] = $row; //Guardem les habitacions lliures a un array
						}
						if (count($ple)==0) {
							$ple=NULL; //totes les habitacions ocupades
						}
				}
		}
		
		else { // Si reservem la casa de colònies
			for($i=$dataInici; $i<=$dataFi; $i=date("Y-m-d", strtotime($i ."+ 1 days"))){  // Busca entre l'interval de dades introduïdes
			$query= "SELECT id FROM reserva WHERE ((reserva.dataInici >= '$i' AND date_sub(reserva.dataFi, INTERVAL 1 DAY) < '$i') OR reserva.dataInici = '$i' OR date_sub(reserva.dataFi, INTERVAL 1 DAY)='$i')AND idAllotjament =2";
			$resultat = $mysqli->query($query); // Consultem totes les reserves de la bases de dades
			if($row = $resultat->FETCH_ASSOC()){
				$ple=NULL; //Enviem un array NULL
				break;
			}
			else {
				$ple = array('id' => 0); //Per la casa de colònies no hem de passar dades, per tant passem qualsevol dada
				
			}
		}
		}

		echo json_encode($ple);
	break;
	
	/******************************************************************************************************/
	case 'afegir': 	// Recull les dades per afegir
	/******************************************************************************************************/
		$reserva = $_POST['reserva'];
		$habs = ($_POST['hab']);
		
		$regim = $_POST['regim'];
		$dataInici = $_POST['dataInici'];
		$dataFi = $_POST['dataFi'];
		
		if ($_POST['reserva']==1) {
			$numPersones = $_POST['numPersonesA']; 
		}
			else {
				$numPersones = $_POST['numPersonesC'];
		}
		
		$dniReserva = $_POST['dniReserva'];
		$nomReserva = $_POST['nomReserva'];
		$cognom1Reserva = $_POST['cognom1Reserva'];
		$cognom2Reserva = $_POST['cognom2Reserva'];
		$emailReserva = $_POST['emailReserva'];
		$telefonReserva = $_POST['telefonReserva'];
		$adreçaReserva = $_POST['adreçaReserva'];
		$observacionsReserva = preg_replace("/'/", "\'", $_POST['observacionsReserva']);


		$query = "SELECT * FROM `usuari` WHERE dni='".$dniReserva."'";  // Si hi ha un usuari a la bbdd amb el mateix DNI actualitza les dades (nom i cognoms s'entén que són els mateixos)
		$resultat = $mysqli->query($query);
		if($row = mysqli_fetch_assoc($resultat)){	 
			$query="UPDATE usuari SET telefon='".$telefonReserva."', email='".$emailReserva."', adreça='".$adreçaReserva."' WHERE dni='".$dniReserva."'";
			$resultat=$mysqli->query($query)or die($mysqli->error);
		}
		else // Si no hi és el crea
		{
			$query= "INSERT INTO usuari (dni, nom, cognom1, cognom2, telefon, email, adreça) VALUES ('$dniReserva','$nomReserva','$cognom1Reserva','$cognom2Reserva','$telefonReserva','$emailReserva','$adreçaReserva')";
			$resultat=$mysqli->query($query)or die($mysqli->error);
		}
		
		// Dades a la bbdd reserva
		if ($_POST['reserva']==1) { // Si reservem l'allotjament
		$personesHab = floor($numPersones/count($habs)); //Com que fem una reserva per cada habitació, el nombre total de persones el dividim entre el total d'habitacions, però no agafem decimamls
				foreach ($habs as $hab) { //Per cada habitació triada fem una reserva
					$query = "INSERT INTO reserva (idAllotjament, idHabitacio, dataInici, dataFi, pax, Regim, dni, comentaris) VALUES ('$reserva', '$hab', '$dataInici','$dataFi', '$personesHab','$regim','$dniReserva','$observacionsReserva')";	
					$resultat = $mysqli->query($query);	
				}
					if (($numPersones%count($habs)) > 0) {//Si és senar vol dir que falta gent per col·locar a l'habitació
						$pers = $numPersones - ($personesHab * count($habs)); //persones que falten col·locar
							$pers2 = $pers + $personesHab;
							$query2 = "UPDATE reserva SET pax = '$pers2' WHERE dni = '".$dniReserva."' AND dataInici = '".$dataInici."' AND idHabitacio = '".$habs[0]."'";	//Actualitzem la base de dades
							$resultat = $mysqli->query($query2);	                                              
					}
		}
		else { // Si reservem la casa de colònies
			$query = "INSERT INTO reserva (idAllotjament, dataInici, dataFi, pax, dni, comentaris) VALUES ('$reserva', '$dataInici','$dataFi', '$numPersones','$dniReserva','$observacionsReserva')";
				$resultat = $mysqli->query($query)or die($mysqli->error);
		}
	break;

	/******************************************************************************************************/
	case 'afegirAP': 	// Recull les dades per afegir des de l'Àrea Privada
	/******************************************************************************************************/
		$reserva = $_POST['reserva'];
		$habs = ($_POST['hab']);
		$regim = $_POST['regim'];
		$dataInici = $_POST['dataInici'];
		$dataFi = $_POST['dataFi'];
		$numPersones = $_POST['numPersones']; 
		$dniReserva = $_POST['dniReserva'];
		$nomReserva = $_POST['nomReserva'];
		$cognom1Reserva = $_POST['cognom1Reserva'];
		$cognom2Reserva = $_POST['cognom2Reserva'];
		$emailReserva = $_POST['emailReserva'];
		$telefonReserva = $_POST['telefonReserva'];
		$adreçaReserva = $_POST['adreçaReserva'];
		$observacionsReserva = preg_replace("/'/", "\'", $_POST['observacionsReserva']);


		$query = "SELECT * FROM `usuari` WHERE dni='".$dniReserva."'";  // Si hi ha un usuari a la bbdd amb el mateix DNI actualitza les dades (nom i cognoms s'entén que són els mateixos)
		$resultat = $mysqli->query($query);
		if($row = mysqli_fetch_assoc($resultat)){	 
			$query="UPDATE usuari SET telefon='".$telefonReserva."', email='".$emailReserva."', adreça='".$adreçaReserva."' WHERE dni='".$dniReserva."'";
			$resultat=$mysqli->query($query)or die($mysqli->error);
		}
		else // Si no hi és el crea
		{
			$query= "INSERT INTO usuari (dni, nom, cognom1, cognom2, telefon, email, adreça) VALUES ('$dniReserva','$nomReserva','$cognom1Reserva','$cognom2Reserva','$telefonReserva','$emailReserva','$adreçaReserva')";
			$resultat=$mysqli->query($query)or die($mysqli->error);
		}
		
		// Dades a la bbdd reserva
		if ($_POST['reserva']==1) { // Si reservem l'allotjament
		$personesHab = $numPersones/count($habs); //Com que fem una reserva per cada habitació, el nombre total de persones el dividim entre el total d'habitacions
				foreach ($habs as $hab) { //Per cada habitació triada fem una reserva
					$query = "INSERT INTO reserva (idAllotjament, idHabitacio, dataInici, dataFi, pax, Regim, dni, comentaris) VALUES ('$reserva', '$hab', '$dataInici','$dataFi', '$personesHab','$regim','$dniReserva','$observacionsReserva')";	
					$resultat = $mysqli->query($query);	
				}
		}
		else { // Si reservem la casa de colònies
			$query = "INSERT INTO reserva (idAllotjament, dataInici, dataFi, pax, dni, comentaris) VALUES ('$reserva', '$dataInici','$dataFi', '$numPersones','$dniReserva','$observacionsReserva')";
				$resultat = $mysqli->query($query)or die($mysqli->error);
		}
	break;


	/******************************************************************************************************/
	case 'modificar': 	// Modifica la reserva
	/******************************************************************************************************/
		//Agafem les noves dades
		$numReserva = $_POST['numReserva'];
		$reserva = $_POST['reserva'];
		$habs = ($_POST['hab']);
		$regim = $_POST['regim'];
		$dataInici = $_POST['dataInici'];
		$dataFi = $_POST['dataFi'];
		$numPersones = $_POST['numPersones']; 
		$dniReserva = $_POST['dniReserva'];
		$nomReserva = $_POST['nomReserva'];
		$cognom1Reserva = $_POST['cognom1Reserva'];
		$cognom2Reserva = $_POST['cognom2Reserva'];
		$emailReserva = $_POST['emailReserva'];
		$telefonReserva = $_POST['telefonReserva'];
		$adreçaReserva = $_POST['adreçaReserva'];
		$observacionsReserva = preg_replace("/'/", "\'", $_POST['observacionsReserva']);
		
		//Modifiquem l'usuari
		$query1="UPDATE usuari SET nom='$nomReserva', cognom1='$cognom1Reserva', cognom2='$cognom2Reserva', telefon='$telefonReserva', adreça= '$adreçaReserva', email= '$emailReserva' WHERE dni='".$dniReserva."'";
		$resultat = $mysqli->query($query1)or die($mysqli->error);
		
		//Modifiquem la reserva
		if ($reserva==1) { // Si reservem l'allotjament
					//$query2="UPDATE reserva SET idAllotjament = '$reserva', idHabitacio = '$hab', dataInici = '$dataInici', dataFi='$dataFi', pax='$numPersones', Regim ='$regim', dni ='$dniReserva', comentaris ='$observacionsReserva' WHERE id='".$numReserva."'";
				foreach ($habs as $hab) {
					$query2 = "UPDATE reserva SET idAllotjament = '$reserva', idHabitacio = '$hab', dataInici = '$dataInici', dataFi='$dataFi', pax='$numPersones', Regim ='$regim', dni='$dniReserva', comentaris='$observacionsReserva' WHERE id='".$numReserva."'";
					$resultat = $mysqli->query($query2)or die($mysqli->error);
				}
		}
		else { // Si reservem la casa de colònies
			$query3 = "UPDATE reserva SET idAllotjament = '$reserva', dataInici = '$dataInici', dataFi='$dataFi', pax='$numPersones', dni='$dniReserva', comentaris='$observacionsReserva' WHERE id='".$numReserva."'";
				$resultat = $mysqli->query($query3)or die($mysqli->error);
		}
		echo json_encode($resultat);
	break;

	/******************************************************************************************************/
	case 'eliminar': 	// Elimina la reserva
	/******************************************************************************************************/
		$id=$_POST['id'];
		$query="DELETE FROM reserva WHERE id=" .$id;
		$resultat = $mysqli->query($query);
		echo json_encode($resultat);
	break;


	/******************************************************************************************************/
	case 'calendari': 	// Busca la info per mostrar-la al calendari
	/******************************************************************************************************/
		//Passem el title, start i end perquè pinti el calendari
		//I tornem a passar aquestes dades normals perquè les llegeixi l'event
		$query = "SELECT 
					r.idAllotjament,					
					CASE
						WHEN r.idAllotjament = 1 THEN a.nom
						ELSE 'Colònies'
                     END AS title,
                    r.dataInici AS start, 
					(r.dataFi +INTERVAL 1 DAY) AS end,
					r.id,
					r.idAllotjament,
					r.idHabitacio, 
					r.dataInici,
					r.dataFi,
					r.pax, 
					r.Regim, 
					r.comentaris,
					u.dni,
					u.nom,
					u.cognom1,
					u.cognom2,
					u.telefon,
					u.email,
					u.adreça,
					CASE
						WHEN r.idAllotjament = 1 THEN a.color
						ELSE '#f7fa9b'
                    END AS color
                    FROM reserva r
					LEFT JOIN usuari u on r.dni = u.dni 
					LEFT JOIN allotjament a on a.id = r.idHabitacio
					LEFT JOIN casacolonies c on c.id = r.idHabitacio";
		
		if($resultat = $mysqli->query($query)){
		     while($row = $resultat->FETCH_ASSOC()) {
		            $myArray[] = $row;
		    }
		    echo json_encode($myArray);
		 }
	break;
}
?>